clan::CheckBoxView Class Reference - ClanLib SDK
Description: clan::CheckBoxView Class Reference

Public Member Functions | Protected Member Functions | List of all members
clan::CheckBoxView Class Reference

`#include <checkbox_view.h>`

Inheritance diagram for clan::CheckBoxView:

## Public Member Functions
| CheckBoxView ()
bool | checked () const
| Check.
bool | disabled () const
std::function< void()> & | func_state_changed ()
| Func state changed.
std::shared_ptr< LabelView > | label ()
void | set_check (bool checked_state)
| Set checked.
void | set_disabled ()
void | set_enabled ()
Public Member Functions inherited from clan::View
| View ()
virtual | ~View ()
const std::vector< std::shared_ptr< ViewAction > > & | actions () const
| List of all action recognizers.
void | add_action (const std::shared_ptr< ViewAction > &action)
| Add an action recognizer.
template<typename T, typename... Types>
std::shared_ptr< T > | add_action (Types &&... args)
std::shared_ptr< View > | add_child ()
void | add_child (const std::shared_ptr< View > &view)
| Add a child view.
template<typename T, typename... Types>
std::shared_ptr< T > | add_child (Types &&... args)
void | animate (float from, float to, const std::function< void(float)> &setter, int duration_ms=400, const std::function< float(float)> &easing=Easing::linear, std::function< void()> animation_end=std::function< void()>())
| Continously call an animation function for the specified duration.
Canvas | canvas () const
const std::vector< std::shared_ptr< View > > & | children () const
| List of all immediate child views.
void | clear_exception_encountered ()
bool | content_clipped () const
| Content clipping flag.
float | definite_height ()
| The content height used for percentages or other definite calculations.
float | definite_width ()
| The content width used for percentages or other definite calculations.
void | draw_without_layout ()
| Render view and its children directly, without re-layout.
std::shared_ptr< View > | find_view_at (const Pointf &pos) const
| Find descendant view at the specified content relative position.
float | first_baseline_offset (Canvas &canvas, float width)
| Calculates the offset to the first baseline.
FocusPolicy | focus_policy () const
| Focus policy active for this view.
View * | focus_view () const
| The view receiving keyboard events or nullptr if no view has the focus.
Pointf | from_root_pos (const Pointf &pos)
| Map from root content to local content coordinates.
Pointf | from_screen_pos (const Pointf &pos)
| Map from screen to local content coordinates.
const ViewGeometry & | geometry () const
| Actual view position and size after layout.
bool | has_focus () const
| Test if this view is receiving keyboard input.
bool | hidden () const
| Test if view is set to hidden.
bool | is_height_definite ()
| Test if the view has a definite height.
bool | is_static_position_and_visible () const
| Test if view should participate in static layout calculations (layout_children).
bool | is_width_definite ()
| Test if the view has a definite width.
float | last_baseline_offset (Canvas &canvas, float width)
| Calculates the offset to the last baseline.
virtual void | layout_children (Canvas &canvas)
| Sets the view geometry for all children of this view.
bool | needs_layout () const
| Test if view geometry needs to be recalculated.
void | next_focus ()
| Give focus to the next view in the keyboard tab index order.
View * | parent () const
| Parent view node or nullptr if the view is the current root node.
float | preferred_height (Canvas &canvas, float width)
| Calculates the preferred height of this view.
float | preferred_width (Canvas &canvas)
| Calculates the preferred width of this view.
void | prev_focus ()
| Give focus to the previous view in the keyboard tab index order.
void | remove_focus ()
| Remove focus from this view.
void | remove_from_parent ()
| Remove view from parent.
bool | render_exception_encountered () const
| Test if this view generated an exception during rendering.
void | set_content_clipped (bool clipped)
| Specifies if content should be clipped during rendering.
void | set_cursor (const CursorDescription &cursor)
| Set the cursor icon used when cursor is above this view.
void | set_cursor (StandardCursor type)
void | set_focus ()
| Set this view as the focused view.
void | set_focus_policy (FocusPolicy policy)
| Set if this view automatically can gain focus.
void | set_geometry (const ViewGeometry &geometry)
void | set_hidden (bool value=true)
| Hides a view from layout and rendering.
void | set_inherit_cursor ()
| Specify that the cursor icon is inherited from the parent view.
void | set_needs_layout ()
| Forces recalculation of view geometry before next rendering.
void | set_needs_render ()
| Signals this view needs to be rendered again.
void | set_state (const std::string &name, bool value)
| Set or clear style state.
void | set_state_cascade (const std::string &name, bool value)
| Sets the state for this view and all children recursively, until a manually set state of the same name is found.
void | set_tab_index (unsigned int index)
| Sets the tab index used for keyboard focus changes.
void | set_view_transform (const Mat4f &transform)
| Specifies the view transform to be applied before its contents and children are rendered.
Signal< void(ActivationChangeEvent &)> & | sig_activated (bool use_capture=false)
| Window activated event.
Signal< void(CloseEvent &)> & | sig_close (bool use_capture=false)
| Window close button clicked event.
Signal< void(ActivationChangeEvent &)> & | sig_deactivated (bool use_capture=false)
| Window deactivated event.
Signal< void(FocusChangeEvent &)> & | sig_focus_gained (bool use_capture=false)
| View gained focus event.
Signal< void(FocusChangeEvent &)> & | sig_focus_lost (bool use_capture=false)
| View lost focus event.
Signal< void(KeyEvent &)> & | sig_key_press (bool use_capture=false)
| Key pressed event.
Signal< void(KeyEvent &)> & | sig_key_release (bool use_capture=false)
| Key released event.
Signal< void(PointerEvent &)> & | sig_pointer_double_click (bool use_capture=false)
| Pointer button double clicked event.
Signal< void(PointerEvent &)> & | sig_pointer_enter (bool use_capture=false)
| Pointer entering view geometry event.
Signal< void(PointerEvent &)> & | sig_pointer_leave (bool use_capture=false)
| Pointer leaving view geometry event.
Signal< void(PointerEvent &)> & | sig_pointer_move (bool use_capture=false)
| Pointer moved above view event.
Signal< void(PointerEvent &)> & | sig_pointer_press (bool use_capture=false)
| Pointer button pressed event.
Signal< void(PointerEvent &)> & | sig_pointer_proximity_change (bool use_capture=false)
| Pointer proximity change event.
Signal< void(PointerEvent &)> & | sig_pointer_release (bool use_capture=false)
| Pointer button released event.
Signal< void(ResizeEvent &)> & | sig_resize (bool use_capture=false)
| Window resize event.
bool | state (const std::string &name) const
| Test if a style state is currently set.
void | stop_animations ()
| Stop all activate animation functions.
const std::shared_ptr< Style > & | style (const std::string &state=std::string()) const
| Style properties for the specified state.
const StyleCascade & | style_cascade () const
| Style cascade currently active for this view.
unsigned int | tab_index () const
| Tab index for keyboard focus changes.
Pointf | to_root_pos (const Pointf &pos, bool relative_to_margin=false)
| Map from local content to root content or margin (plus content, padding, border and margin) coordinates.
Pointf | to_screen_pos (const Pointf &pos)
| Map from local content to screen coordinates.
void | update_cursor (DisplayWindow &window)
| Update window cursor to the cursor used by this view.
const Mat4f & | view_transform () const
| Current view transform.
ViewTree * | view_tree ()
const ViewTree * | view_tree () const
| Tree in view hierachy.

## Protected Member Functions
void | render_background (Canvas &canvas) override
| Override - need to clear background under label due to Subpixel font rendering.
Protected Member Functions inherited from clan::View
virtual float | calculate_definite_height (bool &out_is_definite)
| The content height used for percentages or other definite calculations.
virtual float | calculate_definite_width (bool &out_is_definite)
| The content width used for percentages or other definite calculations.
virtual float | calculate_first_baseline_offset (Canvas &canvas, float width)
| Calculates the offset to the first baseline.
virtual float | calculate_last_baseline_offset (Canvas &canvas, float width)
| Calculates the offset to the last baseline.
virtual float | calculate_preferred_height (Canvas &canvas, float width)
| Calculates the preferred height of this view.
virtual float | calculate_preferred_width (Canvas &canvas)
| Calculates the preferred width of this view.
virtual void | child_added (const std::shared_ptr< View > &view)
| Child view was added to this view.
virtual void | child_removed (const std::shared_ptr< View > &view)
| Child view was removed from this view.
virtual void | render_border (Canvas &canvas)
| Renders the border of a view.
virtual void | render_content (Canvas &canvas)
| Renders the content of a view.
virtual void | updated_view_tree ()

## Additional Inherited Members
Static Public Member Functions inherited from clan::View
static void | dispatch_event (View *target, EventUI *e, bool no_propagation=false)
| Dispatch event to signals listening for events.
Public Attributes inherited from clan::View
SlotContainer | slots
| Slot container helping with automatic disconnection of connected slots when the view is destroyed.

## Constructor & Destructor Documentation

## ◆ CheckBoxView()

clan::CheckBoxView::CheckBoxView | ( |  | ) |

## Member Function Documentation

## ◆ checked()

bool clan::CheckBoxView::checked | ( |  | ) | const

Check.

Returns
  checked state

## ◆ disabled()

bool clan::CheckBoxView::disabled | ( |  | ) | const

## ◆ func_state_changed()

std::function< void()> & clan::CheckBoxView::func_state_changed | ( |  | ) |

Func state changed.

## ◆ label()

std::shared_ptr< LabelView > clan::CheckBoxView::label | ( |  | ) |

## ◆ render_background()

void clan::CheckBoxView::render_background | ( | Canvas & | canvas | ) |
| overrideprotectedvirtual

Override - need to clear background under label due to Subpixel font rendering.

Reimplemented from clan::View.

References clan::View::canvas().

## ◆ set_check()

void clan::CheckBoxView::set_check | ( | bool | checked_state | ) |

Set checked.

Parameters

  enable | = bool

## ◆ set_disabled()

void clan::CheckBoxView::set_disabled | ( |  | ) |

## ◆ set_enabled()

void clan::CheckBoxView::set_enabled | ( |  | ) |

The documentation for this class was generated from the following file:

- checkbox_view.h